#pragma once

#include <iostream>
#include <stdexcept>

#define ASSERT(condition, message) \
    do { \
        if (!(condition)) { \
            std::cerr << "Assertion failed: " << message << std::endl; \
            std::cerr << "File: " << __FILE__ << ", Line: " << __LINE__ << std::endl; \
            throw std::runtime_error(message); \
        } \
    } while (false)
